
/**
 * Zone Manager
 *
 * @package zonemanager
 * @version 2.0
 * @author Bonus Themes
 * @copyright Bonus Themes 2008
 * @license GNU/GPL
 * @link http://www.bonusthemes.com/goto/zonemanager
 */

function ZonePosition(zone)
{
	this.zone = zone;
	this.td = null;

	this.name = null;
	this.width = null;
	this.style = null;
	this.collapsible = null;
	this.group = null;
}

ZonePosition.prototype.is_main_body = function ()
{
	return this.name == null;
}

ZonePosition.prototype.setup_button = function ()
{
	// update zone index
	this.btn.setAttribute('zone_idx', this.zone.idx);
	this.btn.setAttribute('pos_name', this.name);

	// update caption
	clean(this.btn);
	this.btn.appendChild(document.createTextNode(this.is_main_body() ? document.strs.main_body : this.name));

	var img = document.createElement('img');
	this.btn.appendChild(img);
	img.src = document.res.btn_arrow;
}

ZonePosition.prototype.setup_details = function ()
{
	clean(this.details);

	var st = this.width != null ? (document.strs.width + ':' + this.width + 'px') : '';

	if (this.style != null)
		st += (st == '' ? '' : ' - ') + document.strs.style + ':' + (style_exists(this.style) ? this.style : '<span class="error">' + this.style + '</span>');

	if (!this.is_main_body())
		st += (st == '' ? '' : ' - ') + document.strs.collapsible + ':' + (this.collapsible == null || this.collapsible ? document.strs.yes : document.strs.no);

	if (this.group != null)
		st += (st == '' ? '' : ' - ') + document.strs.group + ':' + this.group;

	this.details.innerHTML = st;
}

ZonePosition.prototype.init_internal = function (type)
{
	this.td = document.createElement('td');
	this.td.className = type;
	this.td.setAttribute('valign', 'top');

	this.btn = document.createElement('button');
	this.td.appendChild(this.btn);
	this.btn.setAttribute('type', type);
	this.btn.onclick = function () { document.zm_menu.open(this); }

	this.details = document.createElement('div');
	this.td.appendChild(this.details);

	this.setup_button();
	this.setup_details();
}

ZonePosition.prototype.init_main_body = function ()
{
	this.init_internal('main_body');
}

ZonePosition.prototype.init_zone_position = function (name)
{
	this.name = name;
	this.init_internal('zone_position');
}
