
/**
 * Zone Manager
 *
 * @package zonemanager
 * @version 2.0
 * @author Bonus Themes
 * @copyright Bonus Themes 2008
 * @license GNU/GPL
 * @link http://www.bonusthemes.com/goto/zonemanager
 */

function mkgap()
{
	var gap = document.createElement('div');
	gap.className = 'gap';
	gap.style.width = document.gapsz + 'px';
	gap.style.height = document.gapsz + 'px';
	gap.style.overflow = 'hidden';
	return gap;
}

function mktdgap()
{
	var td = document.createElement('td');
	td.setAttribute('width', '1');
	td.setAttribute('nowrap', '1');
	td.appendChild(mkgap());
	return td;
}

function mktable(parent)
{
	var tbl = document.createElement('table');
	parent.appendChild(tbl);
	tbl.setAttribute('width', '100%');
	tbl.setAttribute('cellSpacing', 0);
	tbl.setAttribute('cellPadding', 0);
	
	var tbd = document.createElement('tbody');
	tbl.appendChild(tbd);

	var tr = document.createElement('tr');
	tbd.appendChild(tr);

	return tr;
}

function clean(parent)
{
	while (true) {
		var obj = parent.firstChild;
		if (!obj) break;
		parent.removeChild(obj);
	}
}

function keep_alive()
{
	var noop_call = null;

	if (window.XMLHttpRequest)
		noop_call = new window.XMLHttpRequest();
	else if (window.ActiveXObject)
		noop_call = new window.ActiveXObject('Microsoft.XMLHTTP');

	if (noop_call) {
		var str = 'option=com_zonemgr&no_html=1&task=noop&' + document.sv + '=1';
		noop_call.open('POST', document.url_aux, true);
		noop_call.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
		noop_call.setRequestHeader("Content-length", str.length);
		noop_call.setRequestHeader("Connection", "close");
		noop_call.send(str);
	}
	else {
		clearInterval(keep_alive_timer);
	}
}
keep_alive_timer = setInterval('keep_alive()', 5000);

staticareas_visible = false;
function show_hide_staticareas()
{
	staticareas_visible = !staticareas_visible;

	document.getElementById('show_hide_btn').innerHTML = staticareas_visible ? document.strs.staticareas_hide : document.strs.staticareas_show;

	var val = staticareas_visible ? 'block' : 'none';

	var elements = document.getElementsByTagName('div');
	for (var i = 0, len = elements.length; i < len; i++)
		if (elements[i].className == 'static_area')
			elements[i].style.display = val;

	var elements = document.getElementsByTagName('tbody');
	for (var i = 0, len = elements.length; i < len; i++)
		if (elements[i].className == 'static_area')
			elements[i].style.display = val;

	var elements = document.getElementsByTagName('td');
	for (var i = 0, len = elements.length; i < len; i++)
		if (elements[i].className == 'static_area')
			elements[i].style.display = val;

	if (staticareas_visible)
		gap_update();
}

function total_width_btn_click()
{
	var st = window.prompt(document.strs.enter_total_width, document.total_width);
	if (st != null) {
		st = st.replace(/^\s+|\s+$/g, '');

		if (st != '') {
			if (!st.match(/^[0-9]+$/)) {
				alert(document.strs.invalid_int);
				return;
			}

			document.total_width = parseInt(st);
			total_width_update();
		}
	}
}

function total_width_update()
{
	var btn = document.getElementById('btn_total_width');
	if (btn) {
		clean(btn);
		btn.appendChild(document.createTextNode(document.total_width + 'px'));
	}
}

function gap_btn_click()
{
	var st = window.prompt(document.strs.enter_gap, document.gapsz);
	if (st != null) {
		st = st.replace(/^\s+|\s+$/g, '');

		if (st != '') {
			if (!st.match(/^[0-9]+$/)) {
				alert(document.strs.invalid_int);
				return;
			}

			document.gapsz = parseInt(st);
			gap_update();
		}
	}
}

function gap_update()
{
	var divs = document.getElementsByTagName('div');
	for (var i = 0, len = divs.length; i < len; i++) {
		if (divs[i].className == 'gap') {
			divs[i].style.width = document.gapsz + 'px';
			divs[i].style.height = document.gapsz + 'px';
		}
	}

	var btn = document.getElementById('btn_gap');
	if (btn) {
		clean(btn);
		btn.appendChild(document.createTextNode(document.gapsz + 'px'));
	}
}

function zone_append()
{
	document.zones.reg['zone_' + document.zones.count] = new Zone(document.zones.count, null);
	document.zones.count++;
}

function zone_edit(way)
{
	var increment = way == 'delete' ? -1 : 1;
	var foundit = false;
	var lookup_id = 'zone_' + document.zm_menu.zone_idx;
	var new_reg = {};
	for (k in document.zones.reg) if (document.zones.reg.hasOwnProperty(k)) {
		if (!foundit) {
			if (k == lookup_id) {
				foundit = true;

				switch (way) {
					case 'delete':
						document.zones.reg[k].delete_it();
						break;

					case 'add_before':
						new_reg['zone_' + document.zones.reg[k].idx] = new Zone(document.zones.reg[k].idx, document.zones.reg[k].wdg);
		
						document.zones.reg[k].increase_idx(1);
						new_reg['zone_' + document.zones.reg[k].idx] = document.zones.reg[k];

						break;

					case 'add_after':
						new_reg['zone_' + document.zones.reg[k].idx] = document.zones.reg[k];
		
						var next_wdg = document.zones.reg[k].wdg.nextSibling;
						if (next_wdg != null)
							next_wdg = next_wdg.nextSibling;
		
						var idx = document.zones.reg[k].idx + 1;
						new_reg['zone_' + idx] = new Zone(idx, next_wdg);

						break;
				}
				
			}
			else {
				new_reg['zone_' + document.zones.reg[k].idx] = document.zones.reg[k];
			}
		}
		else {
			document.zones.reg[k].increase_idx(increment);
			new_reg['zone_' + document.zones.reg[k].idx] = document.zones.reg[k];
		}
	}
	document.zones.reg = new_reg;
	document.zones.count += increment;

	if (way == 'delete')
		review_settings();
}

function zone_init(need_position)
{
	document.zm_menu.close();

	if (document.zm_menu.zone_idx == -1) {
		alert(document.strs.no_zone_selected);
		return false;
	}

	if (need_position && document.zm_menu.pos_name == null) {
		alert(document.strs.no_pos_selected);
		return false;
	}

	return true;
}

function zone_delete()
{
	if (!zone_init(false))
		return;

	if (document.zones.reg['zone_' + document.zm_menu.zone_idx].has_main_body()) {
		alert(document.strs.cannot_delete_zone_mainbody);
		return;
	}

	if (!window.confirm(document.strs.delete_zone))
		return;

	zone_edit('delete');
}

function zone_add_before()
{
	if (!zone_init(false))
		return;

	zone_edit('add_before');
}

function zone_add_after()
{
	if (!zone_init(false))
		return;

	zone_edit('add_after');
}

function zone_set(prop)
{
	if (!zone_init(false))
		return;

	var def = document.zones.reg['zone_' + document.zm_menu.zone_idx][prop];
	if (def == null)
		def = '';

	var st = window.prompt(document.strs['enter_' + prop], def);
	if (st != null) {
		st = st.replace(/^\s+|\s+$/g, '');
		document.zones.reg['zone_' + document.zm_menu.zone_idx][prop] = st == '' ? null : st;
		document.zones.reg['zone_' + document.zm_menu.zone_idx].setup_details();

		review_settings();
	}
}

function zone_move_up()
{
	if (!zone_init(false))
		return;

	if (document.zm_menu.zone_idx == 0) {
		alert(document.strs.zone_top_limit);
		return;
	}

	// move widgets
	var zone_wdg = document.zones.reg['zone_' + document.zm_menu.zone_idx].wdg;
	var zone_gap = zone_wdg.nextSibling;
	var target = zone_wdg.previousSibling.previousSibling;
	target.parentNode.insertBefore(zone_wdg, target);
	target.parentNode.insertBefore(zone_gap, target);

	// rebuild index
	document.zones.reg['zone_' + (document.zm_menu.zone_idx - 1)].increase_idx(1);
	document.zones.reg['zone_' + document.zm_menu.zone_idx].increase_idx(-1);

	var swap = document.zones.reg['zone_' + (document.zm_menu.zone_idx - 1)];
	document.zones.reg['zone_' + (document.zm_menu.zone_idx - 1)] = document.zones.reg['zone_' + document.zm_menu.zone_idx];
	document.zones.reg['zone_' + document.zm_menu.zone_idx] = swap;
}

function zone_move_down()
{
	if (!zone_init(false))
		return;

	if (document.zm_menu.zone_idx == document.zones.count - 1) {
		alert(document.strs.zone_bottom_limit);
		return;
	}

	// move widgets
	var zone_wdg = document.zones.reg['zone_' + document.zm_menu.zone_idx].wdg;
	var zone_gap = zone_wdg.nextSibling;
	if (document.zm_menu.zone_idx == document.zones.count - 2) {
		zone_wdg.parentNode.appendChild(zone_wdg);
		zone_gap.parentNode.appendChild(zone_gap);
	}
	else {
		var target = zone_gap.nextSibling.nextSibling.nextSibling;
		target.parentNode.insertBefore(zone_wdg, target);
		target.parentNode.insertBefore(zone_gap, target);
	}

	// rebuild index
	document.zones.reg['zone_' + document.zm_menu.zone_idx].increase_idx(1);
	document.zones.reg['zone_' + (document.zm_menu.zone_idx + 1)].increase_idx(-1);

	var swap = document.zones.reg['zone_' + document.zm_menu.zone_idx];
	document.zones.reg['zone_' + document.zm_menu.zone_idx] = document.zones.reg['zone_' + (document.zm_menu.zone_idx + 1)];
	document.zones.reg['zone_' + (document.zm_menu.zone_idx + 1)] = swap;
}

function zone_pos_set(prop)
{
	if (!zone_init(true))
		return;

	var pos = document.zones.reg['zone_' + document.zm_menu.zone_idx].get_by_name(document.zm_menu.pos_name);

	var def = pos[prop];
	if (def == null)
		def = '';

	var st = window.prompt(document.strs['enter_' + prop], def);
	if (st != null) {
		st = st.replace(/^\s+|\s+$/g, '');

		if (prop == 'width' && st != '' && !st.match(/^[0-9]+$/)) {
			alert(document.strs.invalid_int);
			return;
		}

		pos[prop] = st == '' ? null : st;
		pos.setup_details();

		review_settings();
	}
}

function zone_pos_switch_collapsible()
{
	if (!zone_init(true))
		return;

	var pos = document.zones.reg['zone_' + document.zm_menu.zone_idx].get_by_name(document.zm_menu.pos_name);
	if (pos.collapsible == null)
		pos.collapsible = true;

	pos.collapsible = !pos.collapsible;
	pos.setup_details();
}

function pos_name_in_use(name, ignore_name)
{
	for (var i = 0, len = document.reserved_positions.length; i < len; i++)
		if (document.reserved_positions[i] == name)
			return true;

	for (var i = 0; i < document.zones.count; i++) {
		var zone = document.zones.reg['zone_' + i];
		for (var k = 0, len = zone.positions.length; k < len; k++) {
			if (ignore_name != '' && zone.positions[k].name == ignore_name)
				continue;

			if (zone.positions[k].name == name)
				return true;
		}
	}

	return false;
}

function zone_pos_rename()
{
	if (!zone_init(true))
		return;

	var pos = document.zones.reg['zone_' + document.zm_menu.zone_idx].get_by_name(document.zm_menu.pos_name);

	var st = window.prompt(document.strs.pos_rename, pos.name);
	if (st != null) {
		st = st.replace(/^\s+|\s+$/g, '');

		if (st != '' && st != pos.name) {
			if (pos_name_in_use(st, pos.name)) {
				alert(document.strs.pos_name_exists);
			}
			else {
				pos.name = st;
				pos.setup_button();
			}
		}
	}

}

function zone_pos_hor_init(check_pos_name)
{
	document.zm_menu.close();

	var error = '';
	var name = null;

	if (document.zm_menu.zone_idx == -1)
		error = document.strs.no_zone_selected;

	if (error == '' && check_pos_name && document.zm_menu.pos_name == null)
		error = document.strs.no_pos_selected;

	if (error == '') {
		name = window.prompt(document.strs.new_pos_name);
		if (name == null)
			return null;
	}

	if (error == '') {
		name = name.replace(/^\s+|\s+$/g, '');
		if (name == '')
			error = document.strs.need_pos_name;
	}

	if (error == '' && !name.match(/^[a-z][a-z0-9_]*$/ig))
		error = document.strs.invalid_pos_name;

	if (error == '' && pos_name_in_use(name, ''))
		error = document.strs.pos_name_exists;

	if (error != '') {
		alert(error);
		name = null;
	}

	return name;
}

function zone_pos_add_start()
{
	var name = zone_pos_hor_init(false);
	if (name != null)
		document.zones.reg['zone_' + document.zm_menu.zone_idx].add_position_start(name);
}

function zone_pos_add_end()
{
	var name = zone_pos_hor_init(false);
	if (name != null)
		document.zones.reg['zone_' + document.zm_menu.zone_idx].add_position_end(name);
}

function zone_pos_add_left()
{
	var name = zone_pos_hor_init(true);
	if (name != null)
		document.zones.reg['zone_' + document.zm_menu.zone_idx].add_position_lr('left', name, document.zm_menu.pos_name);
}

function zone_pos_add_right()
{
	var name = zone_pos_hor_init(true);
	if (name != null)
		document.zones.reg['zone_' + document.zm_menu.zone_idx].add_position_lr('right', name, document.zm_menu.pos_name);
}

function zone_pos_delete()
{
	if (!zone_init(true))
		return;

	if (!window.confirm(document.strs.delete_pos))
		return;

	document.zones.reg['zone_' + document.zm_menu.zone_idx].delete_position(document.zm_menu.pos_name);

	review_settings();
}

function zone_pos_cut()
{
	if (!zone_init(true))
		return;

	document.cut_zone_idx = document.zm_menu.zone_idx;
	document.cut_pos_name = document.zm_menu.pos_name;
}

function zone_pos_paste(type)
{
	if (!zone_init(false))
		return;

	if (document.cut_zone_idx == -1) {
		alert(document.strs.cut_missing);
		return;
	}

	if (typeof document.zones.reg['zone_' + document.cut_zone_idx] == 'undefined') {
		alert(document.strs.cut_zone_missing);
		return;
	}

	var target_pos_name = document.zm_menu.pos_name == null ? '' : document.zm_menu.pos_name;
	if (type != 'start' && type != 'end' && document.cut_zone_idx == document.zm_menu.zone_idx && document.cut_pos_name == target_pos_name) {
		alert(document.strs.paste_self);
		return;
	}

	document.zones.reg['zone_' + document.zm_menu.zone_idx].paste(type, document.zones.reg['zone_' + document.cut_zone_idx], document.cut_pos_name, target_pos_name);
	document.cut_zone_idx = -1;
	document.cut_pos_name = '';
}

function reg_pos_by_name(name)
{
	for (var i = 0, len = document.reg_pos.length; i < len; i++)
		if (document.reg_pos[i].name == name)
			return document.reg_pos[i];

	return null;
}

function reg_pos_init(name, prop, val)
{
	var pos = reg_pos_by_name(name);
	if (pos)
		pos[prop] = val;

	pos.setup_details();
}

function reg_pos_set(prop)
{
	document.zm_menu.close();

	if (document.zm_menu.pos_name == null) {
		alert(document.strs.no_pos_selected);
		return;
	}

	var pos = reg_pos_by_name(document.zm_menu.pos_name);
	if (pos == null)
		return;

	var def = pos[prop];
	if (def == null)
		def = '';

	var st = window.prompt(document.strs['enter_' + prop], def);
	if (st != null) {
		st = st.replace(/^\s+|\s+$/g, '');

		if (prop == 'width' && st != '' && !st.match(/^[0-9]+$/)) {
			alert(document.strs.invalid_int);
			return;
		}

		pos[prop] = st == '' ? null : st;
		pos.setup_details();
	}
}

function gstyle_mouseover(sender, gstyle)
{
	var host = document.getElementById('gstyles_samples');

	var visible = false;
	var obj = host.firstChild;
	while (obj) {
		if (obj.nodeType != 1) {
			// ignore non-element nodes
		}
		else if (obj.id == 'gstyle_' + gstyle) {
			visible = true;
			obj.style.display = 'block';
		}
		else {
			obj.style.display = 'none';
		}

		obj = obj.nextSibling;
	}

	if (visible) {
		var x = sender.offsetWidth, y = sender.offsetHeight + 1, obj = sender;
		while (obj) {
			x += obj.offsetLeft;
			y += obj.offsetTop;
			obj = obj.offsetParent;
		}

		host.style.display = 'block';
		host.style.left = x + 'px';
		host.style.top = (y - host.offsetHeight) + 'px';
	}
}

function gstyle_mouseout(gstyle)
{
	document.getElementById('gstyles_samples').style.display = 'none';
}

function group_exists(name)
{
	if (typeof name == 'string')
		for (var i = 0, len = document.groups.length; i < len; i++)
			if (document.groups[i] == name)
				return true;

	return false;
}

function style_exists(name)
{
	if (typeof name == 'string')
		for (var i = 0, len = document.gstyles.length; i < len; i++)
			if (document.gstyles[i] == name)
				return true;

	return false;
}

function get(value)
{
	return typeof value == 'undefined' || value == null ? '' : value;
}

function h_group_style(inp)
{
	document.group_styles[inp.getAttribute('group_name')] = inp.value;
	review_settings();
}

function review_settings()
{
	document.groups = new Array();
	var zone_bad_styles = 0;
	var pos_bad_styles = 0;
	var group_bad_styles = 0;
	var bad_group_count = 0;
	var bad_group_names = '';
	var group_counts = {};
	var last_group_count_name = '';

	for (var i_zone = 0; i_zone < document.zones.count; i_zone++) {
		var zone = document.zones.reg['zone_' + i_zone];

		if (zone.group != null && zone.group != last_group_count_name) {
			last_group_count_name = zone.group;
			if (typeof group_counts[last_group_count_name] == 'undefined')
				group_counts[last_group_count_name] = 1;
			else
				group_counts[last_group_count_name]++;
		}
	}

	for (var i_zone = 0; i_zone < document.zones.count; i_zone++) {
		var zone = document.zones.reg['zone_' + i_zone];

		if (zone.style != null && !style_exists(zone.style))
			zone_bad_styles++;

		if (zone.group != null && !group_exists(zone.group))
			document.groups.push(zone.group);

		last_group_count_name = '';

		for (var i_pos = 0, len = zone.positions.length; i_pos < len; i_pos++) {
			pos = zone.positions[i_pos];

			if (pos.group != null && pos.group != last_group_count_name) {
				last_group_count_name = pos.group;
				if (typeof group_counts[last_group_count_name] == 'undefined')
					group_counts[last_group_count_name] = 1;
				else
					group_counts[last_group_count_name]++;
			}

			if (pos.style != null && !style_exists(pos.style))
				pos_bad_styles++;

			if (pos.group != null && !group_exists(pos.group))
				document.groups.push(pos.group);
		}
	}

	for (var i = 0; i < document.reg_pos.count; i++) {
		pos = document.reg_pos[i];

		if (pos.style != null && !style_exists(pos.style))
			pos_bad_styles++;
	}

	for (var k in group_counts) {
		if (group_counts.hasOwnProperty(k) && group_counts[k] > 1) {
			bad_group_count++;

			if (bad_group_names != '')
				bad_group_names += ', ';

			bad_group_names += k;
		}
	}

	document.groups.sort();
	var groups_host = document.getElementById('groups_host');
	clean(groups_host);

	for (var i = 0, len = document.groups.length; i < len; i++) {
		var group = document.groups[i];

		var tr = document.createElement('tr');
		groups_host.appendChild(tr);

			var td = document.createElement('td');
			tr.appendChild(td);
			td.appendChild(document.createTextNode(group));

			var td = document.createElement('td');
			tr.appendChild(td);

				var inp = document.createElement('input');
				td.appendChild(inp);
				inp.setAttribute('type', 'text');
				inp.setAttribute('group_name', group);
				inp.setAttribute('value', get(document.group_styles[group]));
				inp.onchange = function () { h_group_style(this); };
				inp.style.color = inp.value != '' && !style_exists(inp.value) ? 'red' : 'black';
	}

	for (var i = 0, len = document.groups.length; i < len; i++)
		if (!style_exists(document.group_styles[document.groups[i]]))
			group_bad_styles++;

	var li, warnings_host = document.getElementById('warnings_host');
	clean(warnings_host);

	if (zone_bad_styles > 0) {
		li = document.createElement('li');
		warnings_host.appendChild(li);
		li.appendChild(document.createTextNode(document.strs.warn_unknown_styles_in_zones.replace(/#/, zone_bad_styles)));
	}

	if (pos_bad_styles > 0) {
		li = document.createElement('li');
		warnings_host.appendChild(li);
		li.appendChild(document.createTextNode(document.strs.warn_unknown_styles_in_positions.replace(/#/, pos_bad_styles)));
	}

	if (group_bad_styles > 0) {
		li = document.createElement('li');
		warnings_host.appendChild(li);
		li.appendChild(document.createTextNode(document.strs.warn_unknown_styles_in_groups.replace(/#/, group_bad_styles)));
	}

	if (bad_group_count > 0) {
		li = document.createElement('li');
		warnings_host.appendChild(li);
		li.appendChild(document.createTextNode(document.strs.warn_duplicate_groups.replace(/#/, bad_group_count) + ': ' + bad_group_names));
	}
}

function save_process()
{
	if (document.ajax.readyState == 4) {
		if (document.ajax.status != 200)
			alert(document.strs.http_error + ' ' + document.ajax.status + ':\n' + document.ajax.responseText);

		document.loading_front.parentNode.removeChild(document.loading_front);
		document.loading_back.parentNode.removeChild(document.loading_back);
	}
}

function save()
{
	if (window.XMLHttpRequest)
		document.ajax = new window.XMLHttpRequest();
	else if (window.ActiveXObject)
		document.ajax = new window.ActiveXObject('Microsoft.XMLHTTP');

	if (!document.ajax) {
		alert(document.strs.need_ajax);
	}
	else {
		// prepare loading message layer

		var w = 0, h = 0;
		if (window.innerWidth) {
			w = window.innerWidth;
			h = window.innerHeight;
		}
		else if (document.documentElement && document.documentElement.clientWidth) {
			w = document.documentElement.clientWidth;
			h = document.documentElement.clientHeight;
		}
		else if (document.body && document.body.clientWidth) {
			w = document.body.clientWidth;
			h = document.body.clientHeight;
		}

		var loading_parent = document.getElementsByTagName('body')[0];

		document.loading_back = document.createElement('div');
		document.loading_back.className = 'loading_back';
		loading_parent.appendChild(document.loading_back);
		document.loading_back.style.width = w + 'px';
		document.loading_back.style.height = h + 'px';

		document.loading_front = document.createElement('div');
		document.loading_front.className = 'loading_front';
		loading_parent.appendChild(document.loading_front);
		document.loading_front.innerHTML = '<p align="center"><img src="components/com_zonemgr/images/hourglass.gif"><br/>' + document.strs.saving + '</p>';
		document.loading_front.style.left = Math.round((w - document.loading_front.offsetWidth) / 2) + 'px';
		document.loading_front.style.top = Math.round((h - document.loading_front.offsetHeight) / 2) + 'px';


		// prepare and send request

		var params = {
			option: 'com_zonemgr',
			no_html: '1',
			task: 'save',
			tpl_filename: document.tpl_filename,
			reserved_positions: document.reserved_positions.join(','),
			gapsz: document.gapsz,
			total_width: document.total_width
		};
		params[document.sv] = 1;

		for (var i = 0, len = document.reg_pos.length; i < len; i++) {
			var pos = document.reg_pos[i];

			params['regpos[' + pos.name + '][width]'] = get(pos.width);
			params['regpos[' + pos.name + '][style]'] = get(pos.style);
		}

		for (var i_zone = 0, len = document.zones.count; i_zone < len; i_zone++) {
			var zone = document.zones.reg['zone_' + i_zone];

			params['zones[' + i_zone + '][style]'] = get(zone.style);
			params['zones[' + i_zone + '][group]'] = get(zone.group);

			for (var i_pos = 0, len2 = zone.positions.length; i_pos < len2; i_pos++) {
				params['zones[' + i_zone + '][pos][' + i_pos + '][name]'] = get(zone.positions[i_pos].name);
				params['zones[' + i_zone + '][pos][' + i_pos + '][width]'] = get(zone.positions[i_pos].width);
				params['zones[' + i_zone + '][pos][' + i_pos + '][style]'] = get(zone.positions[i_pos].style);
				params['zones[' + i_zone + '][pos][' + i_pos + '][collapsible]'] = get(zone.positions[i_pos].collapsible);
				params['zones[' + i_zone + '][pos][' + i_pos + '][group]'] = get(zone.positions[i_pos].group);
			}
		}

		for (var i = 0, len = document.groups.length; i < len; i++)
			params['groups[' + document.groups[i] + ']'] = get(document.group_styles[document.groups[i]]);

		var str = '';
		for (k in params) if (params.hasOwnProperty(k)) {
			if (str != '') str += '&';
			str += k + '=' + encodeURIComponent(params[k]).replace(/%20/g, '+');
		}

		document.ajax.open('POST', document.url_aux, true);
		document.ajax.onreadystatechange = save_process;
		document.ajax.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
		document.ajax.setRequestHeader("Content-length", str.length);
		document.ajax.setRequestHeader("Connection", "close");
		document.ajax.send(str);
	}

	return false;
}
